#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "fp_template") { &start; }
if ($q->param('fct') eq "save_topvar") { &save_topvar; }
if ($q->param('fct') eq "save_fp_template") { &save_fp_template; }
if ($q->param('fct') eq "save_fppath") { &save_fppath; }


##################################################################################

sub save_topvar
{

$topvar = $q->param('topvar');

open (CTMPL, "> $data_dir/frontlink.dat");
	print CTMPL $topvar;
close (CTMPL);
$stat = chmod($default_permissions,"$data_dir/frontlink.dat","$data_dir/frontlink.dat"); 


$hbox = acs::get_heading_box("$web_url/ic_frontp3.gif", "URL to Front Page Saved", qq[
<a href="$admin_url/admin26.cgi">Click Here to Continue</a>
]);
 


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}





sub save_fppath
{

### LET'S TEST TO SEE IF WE CAN WRITE TO THE LOCATION SUPPLIED

$fpwrite_file = $q->param('fpfile');
open (FPW, "> $fpwrite_file") or acs::problem_popup("Could not write to the path you specified. Make sure the path exists and that the directory where the file needs to be written to is writable.");

$fpsettings1 = acs::get_file_contents("$data_dir/fp.cfg");
(@fp_settings1) = split (/\n/, $fpsettings1);
$allcats = psfp::generate_categories();
$allcats =~ s/\n/ /g;
$crit = chr(10); $allcats =~ s/$crit/ /g;
$crit = chr(13); $allcats =~ s/$crit/ /g;
$allcats =~ s/'/\\'/g;

$fphtml = acs::get_file_contents("$data_dir/psfp.html");
$fphtml =~ s/!!categories!!/$allcats/gi;
$fphtml = acs::ts_insert_template_includes($fphtml); 
$fphtml = acs::fill_vars($fphtml); 

print FPW $fphtml;
close (FPW);


open (FF, "> $data_dir/fpwrite.dat");
	print FF $fpwrite_file;
close (FF);



print qq[

<html>

<head>
<title>PowerSeek</title>
</head>

<body>

<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img src="$web_url/ic_frontp3.gif"></td>
    <td width="95%" valign="top"><font face="Arial" size="4"><strong>Path Saved</strong></font><font
    color="#0000a0" face="Arial" size="4"><br>
    </font><a href="$admin_url/admin61.cgi?fct=fp_template"><font face="Verdana" size="1">Click
    here to continue</font></a></td>
  </tr>
</table>

<hr noshade size="1" color="#F2F2F2">
</body>
</html>
];




}




sub save_fp_template
{

$fpwrite_file = acs::get_file_contents("$data_dir/fpwrite.dat");
if (length($fpwrite_file) < 2)
	{
	$fpwrite_file = "$web_dir/fp.html";
	}


#$fp_flname =  $q->param('fpfile');
#if (-e "$fp_flname")
#	{
#	open (FPW, "> $data_dir/fpwrite.dat");
#		print FPW $fp_flname;
#	close (FPW);
#	}


$fpsettings1 = acs::get_file_contents("$data_dir/fp.cfg");
(@fp_settings1) = split (/\n/, $fpsettings1);
$allcats = psfp::generate_categories();

$allcats =~ s/\n/ /g;
$crit = chr(10); $allcats =~ s/$crit/ /g;
$crit = chr(13); $allcats =~ s/$crit/ /g;
$allcats =~ s/'/\\'/g;


$fphtml = acs::get_file_contents("$data_dir/psfp.html");
$fphtml =~ s/!!categories!!/$allcats/gi;
$fphtml = acs::ts_insert_template_includes($fphtml); 
$fphtml = acs::fill_vars($fphtml); 

open (FPW, "> $fpwrite_file");
	print FPW $fphtml;
close (FPW);


$html = $q->param('fptemplate');
open (FP, "> $data_dir/psfp.html");
	print FP $html;
close (FP);


$hbox = acs::get_heading_box("$web_url/ic_frontp3.gif", "Template Saved", qq[
<a href="$admin_url/admin26.cgi">Click Here to Continue</a>
]);
 
$hprev = acs::get_heading_box("$web_url/ic_frontp3.gif", "Front Page Preview", qq[
Below is a Preview of how the Front Page looks like using the 'Front Page Template' method.
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox

$hprev

<IFRAME src="$script_url/fp.cgi" width="100%" height="500">
<!--webbot bot="HTMLMarkup" endspan --> <!--webbot bot="HTMLMarkup" startspan -->
</IFRAME>

</body>
</html>
];





}







sub start
{

$fp_write_path = acs::get_file_contents("$data_dir/fpwrite.dat"); 

if (length($fp_write_path) < 2)
	{
	$fpfile = "$web_dir/fp.html";	
	}
	else
	{
	$fpfile = "$fp_write_path";	
	}


$fp_html = acs::get_file_contents("$data_dir/psfp.html"); 


$topvar = acs::get_file_contents("$data_dir/frontlink.dat"); 


print qq[

<html>

<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>

<body>

<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img src="$web_url/ic_frontp3.gif"></td>
    <td width="88%" valign="top"><font face="Arial" size="4"><strong>FrontPage Template</strong></font><font
    color="#0000a0" face="Arial" size="4"><br>
    </font><font face="Verdana" size="1">Use this option to use a template for your front
    page. You may edit the template that is being used for your front page below.<br>
    <a href="$admin_url/admin26.cgi">Go Back</a></font></td>
    <td width="7%" valign="top" align="right"><font face="Arial" size="4" color="#000000"><strong><a
    href="$admin_url/help.cgi?fct=fp_template" target="_blank"><img src="$web_url/bhelps.gif"
    border="0"></a></strong></font></td>
  </tr>
</table>

<hr noshade size="1" color="#F2F2F2">

<form method="POST" action="$admin_url/admin61.cgi">
  <input type="hidden" name="fct" value="save_fp_template"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td width="100%" bgcolor="#FFE135"><font face="Verdana" size="1"><strong>Edit Front Page
      Template (<a href="$script_url/fp.cgi" target="_blank">Preview Front Page</a>)</strong></font></td>
    </tr>
    <tr>
      <td width="100%" bgcolor="#FFFFFF"><div align="center"><center><p><strong><font
      face="Verdana" size="1">Copy and paste the HTML code below into your web browser to edit
      the look and feel of your front page.</font></strong><br>
      <br>
      <textarea rows="14" name="fptemplate" cols="99"
      style="font-family: MS Sans Serif; font-size: 8">$fp_html</textarea></p>
      </center></div><div align="center"><center><p><input type="submit" value="   Save   "
      name="B1"></p>
      </center></div><blockquote>
        <p><font face="Verdana" size="1"><strong>The front page template is located here:<br>
        <font color="#0000FF">$data_dir/psfp.html</font></strong></font></p>
      </blockquote>
      <blockquote>
        <div align="left"><p><font face="Verdana" size="1"><strong>Your front page can be accessed
        from:<br>
        <a href="$script_url/fp.cgi" target="_blank">$script_url/fp.cgi</a></strong></font></p>
        </div><div align="left"><p><font face="Verdana" size="1"><strong>The following variables
        is used in this template:<br>
        </strong>Variables are the words enclosed by !! - it is replaced by front page categories
        and other data.</font></p>
        </div><blockquote>
          <div align="left"><p><font face="Verdana" size="1"><strong>!!categories!!<br>
          </strong>This variable is replaced by your front page categories. You can define the style
          of it by going to the <br>
          Control Panel &gt;&gt; To Do &gt;&gt; Generate Front Page &gt;&gt; Front Page Category
          Creation/Generation Settings</font></p>
          </div>
        </blockquote>
        <div align="left"><p><font face="Verdana" size="1"><strong>The variables below are
        available in this template and all other PowerSeek templates:</strong></font></p>
        </div><blockquote>
          <div align="left"><p><font face="Verdana" size="1"><strong>!!add_premium_url_link!!<br>
          </strong>Replaced by a hyperlink to the premium add URL form.<br>
          <br>
          <strong>!!add_url_link!!</strong><br>
          Replaced by a hyperlink to the add URL form.</font></p>
          </div><div align="left"><p><font face="Verdana" size="1"><strong>!!tophits!!<br>
          </strong>Replaced by a hyperlink to the page that lists the most popular links in the
          directory.<br>
          <br>
          <strong>!!whatsnew!!<br>
          </strong>Replaced by a hyperlink to the page that lists the most recent additions to the
          directory.<br>
          <br>
          <strong>!!rgs_login!!<br>
          </strong>Replaced by a hyperlink to the user login page. Note that you must use the user
          registration system for this option so that users can register accounts to submit their
          links.<br>
          <br>
          <strong>!!register!!<br>
          </strong>Replaced by a hyperlink to the registration form that users fill in to register
          an account.<br>
          <br>
          <strong>!build_url!<br>
          </strong>Replaced by a hyperlink to the 'html' directory or the PowerSeek directory that
          holds it's image files.</font></p>
          </div><div align="left"><p><font face="Verdana" size="1"><strong>!!tseeksearch!!<br>
          </strong>Replaced by a hyperlink to the search script that takes care of searching.
          Typically used in a search form. <br>
          </font></p>
          </div>
        </blockquote>
        <div align="left"><p><font face="Verdana" size="1">Note that you may also use template
        includes with this template. For more on this go to the <br>
        Control Panel &gt;&gt; Template Manager &gt;&gt; Create/Edit Template Includes </font></p>
        </div><font face="Verdana" size="1"><p><a href="$admin_url/admin36.cgi" target="_blank">Click
        here to find out how to use images inside of your templates</a><br>
        &nbsp;&nbsp;&nbsp;&nbsp; </font></p>
      </blockquote>
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

<form method="POST" action="$admin_url/admin61.cgi">
  <input type="hidden" name="fct" value="save_fppath"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td width="100%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><strong>If you would like
      this template to be written to a file then specify the path below:</strong><br>
      <input type="text" name="fpfile" size="86" value="$fpfile"> <input type="submit"
      value="Save" name="B1"></font><blockquote>
        <p><font face="Verdana" size="1">The above path's default value is: <strong>$web_dir/fp.html</strong><br>
        and if written to that location can be accessed from here:<br>
        <strong><a href="$web_url/fp.html" target="_blank">$web_url/fp.html</a><br>
        </strong>Note that if you have never saved the front page template then the above link
        will give a 404 page not found error.</font></p>
      </blockquote>
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

<form method="POST" action="$admin_url/admin61.cgi">
  <input type="hidden" name="fct" value="save_topvar"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td width="100%" bgcolor="#FFFFFF"><font face="Verdana" size="1"><strong>!!top!! variable
      (Link to Front Page of Search Engine &amp; Directory)<br>
      </strong>Inside the default template set and template sets that comes with PowerSeek there
      is a variable called !!top!! that is used as a link to the front page of your Search
      Engine &amp; Directory. The !!top!! variable is replaced with a link to the Front Page
      template (The index or front page of your Search Engine &amp; Directory). If you are not
      using the Front Page Template (as the front page of your Search Engine &amp; Directory)
      and are using a standard HTML page then you can set it up here so that the !!top!!
      variable is replaced by a link to your Front Page that works from a normal HTML file.</font><p><font
      face="Verdana" size="1"><input type="text" name="topvar" size="86" value="$topvar"> <input
      type="submit" value="Save" name="B1"></font></p>
      <blockquote>
        <p><font face="Verdana" size="1">If the Index or Front Page of your Search Engine &amp;
        Directory is called index.html and in the root level of your domain then you could enter
        for example:<br>
        <strong>http://www.somedomain.com</strong><br>
        above. Leave this blank if you are using the Front Page template as a Front or Index page for your Search Engine & Directory.</font></p>
      </blockquote>
      <p>&nbsp;</td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>
</body>
</html>

];


}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

